/* Arduino example sketch to control a JSN-SR04T ultrasonic distance sensor with Arduino. No library needed. More info: https://www.makerguides.com */
/* Modified by Kitty Yeung for use with Adafruit Gemma for social distancing mask www.kittyyeung.com */

#include <SoftwareSerial.h>

// Define Trig and Echo pin:
#define trigPin 2
#define echoPin 0
SoftwareSerial mySerial = SoftwareSerial(0,2); 

// Define variables:
long duration;
int distance;

int led = 1;

void setup() {
  // Define inputs and outputs
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  // initialize the digital pin as an output.
  pinMode(led, OUTPUT);
  
  // Begin Serial communication at a baudrate of 9600:
  mySerial.begin(9600);
}

void loop() {
  // Clear the trigPin by setting it LOW:
  digitalWrite(trigPin, LOW);
  
  delayMicroseconds(5);

 // Trigger the sensor by setting the trigPin high for 10 microseconds:
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  
  // Read the echoPin. pulseIn() returns the duration (length of the pulse) in microseconds:
  duration = pulseIn(echoPin, HIGH);
  
  // Calculate the distance:
  distance = duration*0.034/2;

  if (distance < 200){
    digitalWrite(led, HIGH); 
    }
  else {
    digitalWrite(led, LOW); 
    }  

  //Below serial port printing wouldn't work on Gemma. Will just trust physics. (The Gemma doesn't have any real USB hardware, only a bootloader that emulates a low-speed USB connection for long enough to upload firmware.)
  // Print the distance on the Serial Monitor (Ctrl+Shift+M): 
  mySerial.print("Distance = ");
  mySerial.print(distance);
  mySerial.println(" cm");
  
  delay(100);
}
